//+------------------------------------------------------------------+
//|                                          analizators_shablon.mqh |
//|                             Copyright  2012 valenok2003@mail.ru |
//+------------------------------------------------------------------+
//|                         
//|                   include
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
string  ex_Name = NAME_EXPERT;
//-----------------------------------  
#property indicator_separate_window
#property indicator_minimum -1
#property indicator_maximum  1
//-----------------------------------  
#property indicator_buffers 4       //  
#property indicator_color1 LimeGreen
#property indicator_color2 LimeGreen
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_level1 0.0
#property indicator_levelcolor Gray 
//-----------------
int      SO, 
         SC, 
         Cnt,
         Signal,         
         Old_Trand;
//-----------------
string   Name_Window,
         Name_Obj1, 
         Name_Obj2,
         GV_Name_Open,
         GV_Name_Close;
//---- buffers ----
double   Green_Open_Line[],
         Green_Close_Line[],
         Red_Open_Line[],
         Red_Close_Line[];
//-----------end blue drim head -------------------------------------+
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                16.02.2012
//+------------------------------------------------------------------+
//| check_common_control()       
//+------------------------------------------------------------------+
extern bool    REVERS_SIGNAL  = false; //  
extern bool    COMMON_CONTROL = true; // false -   
extern string  Rem3 = "-    -";
extern bool    usONLY_BUY     = false;
extern bool    usONLY_SELL    = false;
extern bool    usONLY_OPEN    = false;
extern string  Rem3_1 = "-  -";
extern bool    usComment_ON      = false;
extern bool    usTOTAL_SILENCE   = false; // true -   
extern bool    usAlert_ON     = false; 
extern bool    usSound_ON     = false;        
extern string  Rem3_2 = "-    -";
extern string  Name_Sound     = "alert2.wav";
//    
bool  ONLY_BUY, 
      ONLY_SELL,
      ONLY_OPEN,
      Comment_ON,
      TOTAL_SILENCE,
      Alert_ON,
      Sound_ON;
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                2011.12.13
//+------------------------------------------------------------------+
//| check_common_control() 
//|   GV-     
//|     
//|       false
//|        
//|     
//+------------------------------------------------------------------+
void check_common_control() {
   string _Function = "check_common_control():";
   string _Txt = "";
//-----------------
   if(COMMON_CONTROL){
      if(GlobalVariableCheck(Symbol() + "_ONLY_BUY")) 
         ONLY_BUY = double_in_bool(GlobalVariableGet(Symbol() + "_ONLY_BUY"));
      else{ ONLY_BUY = usONLY_BUY;           }
      if(GlobalVariableCheck(Symbol() + "_ONLY_SELL")) 
         ONLY_SELL = double_in_bool(GlobalVariableGet(Symbol() + "_ONLY_SELL"));
      else{ ONLY_SELL = usONLY_SELL;         }
      if(GlobalVariableCheck(Symbol() + "_ONLY_OPEN")) 
         ONLY_OPEN = double_in_bool(GlobalVariableGet(Symbol() + "_ONLY_OPEN"));
      else{ ONLY_OPEN = usONLY_OPEN;         }
      if(GlobalVariableCheck(Symbol() + "_Comment_ON")) 
         Comment_ON = double_in_bool(GlobalVariableGet(Symbol() + "_Comment_ON"));
      else{ Comment_ON = usComment_ON;       }
      if(GlobalVariableCheck(Symbol() + "_Alert_ON")) 
         Alert_ON = double_in_bool(GlobalVariableGet(Symbol() + "_Alert_ON"));
      else{ Alert_ON = usAlert_ON;           }
      if(GlobalVariableCheck(Symbol() + "_Sound_ON")) 
         Sound_ON = double_in_bool(GlobalVariableGet(Symbol() + "_Sound_ON"));
      else{ Sound_ON = usSound_ON;           }
      if(GlobalVariableCheck(Symbol() + "_TOTAL_SILENCE")) 
         TOTAL_SILENCE = double_in_bool(GlobalVariableGet(Symbol() + "_TOTAL_SILENCE"));
      else{ TOTAL_SILENCE = usTOTAL_SILENCE; }
   }
   else {
      ONLY_BUY    = usONLY_BUY;
      ONLY_SELL   = usONLY_SELL;
      ONLY_OPEN   = usONLY_OPEN;
      Comment_ON  = usComment_ON;
      Alert_ON    = usAlert_ON;
      Sound_ON    = usSound_ON;
      TOTAL_SILENCE = usTOTAL_SILENCE;
   }
//----  ------------------------------------------------------
   if(ONLY_BUY && ONLY_SELL){
      Alert("  ONLY_BUY  ONLY_SELL! ");
      ONLY_BUY  = false;
      ONLY_SELL = false;
   }
//-----------------
   return;
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                2011.12.13
//+------------------------------------------------------------------+
//| double_in_bool()   0.0  1.0   
//+------------------------------------------------------------------+
bool double_in_bool(double _var)  {
   string _Function = "double_in_bool():";
   if(_var != 1.0 && _var != 0.0) Alert(_Function + "  ");
   if(_var == 1.0) return(true);
   else return(false);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                14.06.2011
//+------------------------------------------------------------------+
//| txt_TF()                   
//+------------------------------------------------------------------+
string txt_TF( int _TF){  
   string _Function = "txt_TF():";
   string _Txt_TF;
   switch(_TF) {
     case PERIOD_M1:  _Txt_TF = "M1";  break;
     case PERIOD_M5:  _Txt_TF = "M5";  break;
     case PERIOD_M15: _Txt_TF = "M15"; break;
     case PERIOD_M30: _Txt_TF = "M30"; break;
     case PERIOD_H1:  _Txt_TF = "H1";  break;
     case PERIOD_H4:  _Txt_TF = "H4";  break;
     case PERIOD_D1:  _Txt_TF = "D1";  break;
     case PERIOD_W1:  _Txt_TF = "W1";  break;
     case PERIOD_MN1: _Txt_TF = "MN1"; break;
     default: Alert(_Function +":   " + _TF); break;
   }
   return(_Txt_TF);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
int check_TF(int _TF){  
   string _Function = "check_TF():";
   if(_TF == 0 || _TF < Period()) _TF = Period(); //      -   
   switch(_TF) {
     case PERIOD_M1:  break;
     case PERIOD_M5:  break;
     case PERIOD_M15: break;
     case PERIOD_M30: break;
     case PERIOD_H1:  break;
     case PERIOD_H4:  break;
     case PERIOD_D1:  break;
     case PERIOD_W1:  break;
     case PERIOD_MN1: break;
      default: 
         _TF = Period();                  //     -   
         Alert(_Function+":  TF,    " + Period());
         break; 
   }
   return(_TF);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                29.10.2012
//+------------------------------------------------------------------+
//| output_alert_or_sound()  
//| :
//| - 
//| -    
//+------------------------------------------------------------------+
void output_alert_or_sound(string _Txt, string _Name_Sound) {
   string _Function = "output_alert_or_sound():";
//----------------- 
   string _Txt_Alert;
//----------------- 
   if(Alert_ON) {
      _Txt_Alert = _Txt + " " + txt_TF(Period())+" "+Symbol() + ex_Name;
      Alert(_Txt_Alert);
   }
   else {
      if(Sound_ON) {
         PlaySound(_Name_Sound);
         Print(" : " + TimeLocal());
         Print(_Txt_Alert + " -  "); 
      }    
   }
//-----------------   
   return;
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
//----
//-------------- blue drim part init --------------------------------+
//----    --------------------------------------
   TF_Indicator = check_TF(TF_Indicator); // TF_Indicator -      .
//-----------------
//---- indicators ----------------------------------------------------
   SetIndexBuffer(0,Green_Open_Line);
   SetIndexStyle (0,DRAW_HISTOGRAM,0,0,LimeGreen);
   
   SetIndexBuffer(1,Green_Close_Line);
   SetIndexStyle (1,DRAW_HISTOGRAM,0,0,LimeGreen);
   
   SetIndexBuffer(2,Red_Open_Line);
   SetIndexStyle (2,DRAW_HISTOGRAM,0,0,Red);
   
   SetIndexBuffer(3,Red_Close_Line);
   SetIndexStyle (3,DRAW_HISTOGRAM,0,0,Red);
//--------------------------------------------------------------------
//---        -------
//---    ---------------------------------------
   string GV_Name_Open_Base  = Symbol() + "_" + "Signal_OPEN"  + "_";
   string GV_Name_Close_Base = Symbol() + "_" + "Signal_CLOSE" + "_";
//---    ----------------------------------------
   bool ALLOW_SET_OPEN_NAME = true;
   bool ALLOW_SET_CLOSE_NAME = true;
   //       
   for(int i = 1; i <= 100; i++) { 
      if(ALLOW_SET_OPEN_NAME && !GlobalVariableCheck(GV_Name_Open_Base + i)) {
         GV_Name_Open  = GV_Name_Open_Base + i;
         GlobalVariableSet(GV_Name_Open,SIGNAL_NO);
         SO = i;
         ALLOW_SET_OPEN_NAME = false;
      }
      if(ALLOW_SET_CLOSE_NAME && !GlobalVariableCheck(GV_Name_Close_Base + i)) {
         GV_Name_Close = GV_Name_Close_Base + i;
         GlobalVariableSet(GV_Name_Close,SIGNAL_NO); 
         SC = i;
         ALLOW_SET_CLOSE_NAME = false;
      }        
   } 
//--------------------------------------------------------------------
//---- name for indicator window

//---------------------------   
   Name_Window = txt_TF(TF_Indicator)+" "+ex_Name+" "+VER+" SO"+SO+" SC"+SC+" ";
   IndicatorShortName(Name_Window);
//-------------- end blue drim part init ----------------------------+
//----
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
//-------------- blue drim part deinit ------------------------------+
   //      
   GlobalVariableDel(GV_Name_Open);
   GlobalVariableDel(GV_Name_Close);
   ObjectDelete(Name_Obj1);
   ObjectDelete(Name_Obj2);
//           
   Drow_Open_No_Signal();
   Drow_Close_No_Signal();
//-------------- end blue drim part deinit --------------------------+
//----
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
   check_common_control();
//--------------------------------------------------------------------
      Name_Obj1 = "ADVERT "+SO+SC; // SO+SC   
      ObjectCreate (Name_Obj1, OBJ_LABEL, WindowFind(Name_Window), 0, 0);
      ObjectSet    (Name_Obj1, OBJPROP_CORNER, 2);
      ObjectSet    (Name_Obj1, OBJPROP_XDISTANCE, 5);
      ObjectSet    (Name_Obj1, OBJPROP_YDISTANCE, 5);
      ObjectSetText(Name_Obj1, ADVERT, 10, "Arial", LimeGreen);
//--------------------------------------------------------------------
      Signal = get_signal();
//--------------------------------------------------------------------
//----    ----------------------------------------
   if(REVERS_SIGNAL)
   {  switch(Signal)
      {  case SIGNAL_UP: Signal = SIGNAL_DN; break;
         case SIGNAL_DN: Signal = SIGNAL_UP; break;
         default: break;
      }
   }
//--------------------------------------------------------------------
//----    ---------------------------------------
   static bool TRIGER_UP = true;
   static bool TRIGER_DN = true;
   if(Signal == SIGNAL_NO) {
      Open_No_Signal();
      Drow_Open_No_Signal();
      Close_No_Signal();
      Drow_Close_No_Signal();
   }
//--------------------------------------------------------------------
   if(Signal==SIGNAL_UP) { 
      if(!ONLY_OPEN){
         if(!ONLY_SELL){
            Open_Buy();   Drow_Open_Buy(); 
         }
         if(!ONLY_BUY){
            Close_Sell(); Drow_Close_Sell();
         }
      }
      else {
         if(!ONLY_SELL){
            Open_Buy(); Drow_Open_Buy(); 
            Close_No_Signal(); Drow_Close_No_Signal(); 
         }
      }
   }
   if(TRIGER_UP){
      output_alert_or_sound("C UP", Name_Sound);
      TRIGER_UP = false;
      TRIGER_DN = true; 
   }
//--------------------------------------------------------------------
   if(Signal==SIGNAL_DN){  
      if(!ONLY_OPEN){
         if(!ONLY_SELL){
            Close_Buy(); Drow_Close_Buy();
         }
         if(!ONLY_BUY){
            Open_Sell(); Drow_Open_Sell(); 
         }
      }
      else {
         if(!ONLY_BUY){
            Open_Sell(); Drow_Open_Sell(); 
            Close_No_Signal(); Drow_Close_No_Signal();
         }
      }
   }
   if(TRIGER_DN){
      output_alert_or_sound("C DN", Name_Sound);
      TRIGER_DN = false;
      TRIGER_UP = true; 
   }
//--------------------------------------------------------------------
//--------------------------------------------------------------------
//----
   return(0);
}
//+------------------------------------------------------------------+
//                             
//+------------------------------------------------------------------+
//+-------
//+-------
//+-------------------   ---------------------------+
void Drow_Open_Buy()
{Green_Open_Line[0] = +0.7;return;}
//+------------------------------------------------------------------+
void Drow_Open_Sell()
{Red_Open_Line[0] = -0.7; return;}
//+------------------------------------------------------------------+
void Drow_Open_No_Signal()
{Green_Open_Line[0] = 0; Red_Open_Line[0] = 0; return;}
//+-------------------   ---------------------------+
void Drow_Close_Buy()
{Green_Close_Line[0] = +0.2; return;}
//+------------------------------------------------------------------+
void Drow_Close_Sell()
{Red_Close_Line[0] = -0.2; return;}
//+------------------------------------------------------------------+
void Drow_Close_No_Signal()
{Green_Close_Line[0] = 0; Red_Close_Line[0] = 0; return;}
//+------------------------------------------------------------------+
//+-------------    --------------------+
void Open_Buy()
{GlobalVariableSet(GV_Name_Open,+1.0); return;}
//+------------------------------------------------------------------+
void Open_Sell()
{GlobalVariableSet(GV_Name_Open,-1.0); return;}
//+------------------------------------------------------------------+
void Open_No_Signal()
{GlobalVariableSet(GV_Name_Open,0.0); return;}
//+------------------------------------------------------------------+
void Close_Buy()
{GlobalVariableSet(GV_Name_Close,-1.0); return;}
//+------------------------------------------------------------------+
void Close_Sell()
{GlobalVariableSet(GV_Name_Close,+1.0); return;}
//+------------------------------------------------------------------+
void Close_No_Signal()
{GlobalVariableSet(GV_Name_Close,0.0); return;}
//+------------------------------------------------------------------+
//+-------

